-- settings.lua
-- Written by Habna


-- **v Load / update / set default settings v**
function LoadSettings()
	if GLocale == "de" then settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsDE" ); end
	if GLocale == "en" then settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsEN" ); end
	if GLocale == "fr" then settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsFR" ); end
	
	if settings == nil then
		TBLocale = GLocale;
		bcAlpha, bcRed, bcGreen, bcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for TitanBar
		MbcAlpha, MbcRed, MbcGreen, MbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Money Control
		DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Destiny points Control
		BbcAlpha, BbcRed, BbcGreen, BbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Bag Control
		PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Player infos Control
		EIbcAlpha, EIbcRed, EIbcGreen, EIbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Equipement infos Control
		DIbcAlpha, DIbcRed, DIbcGreen, DIbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Durability infos Control

		PLbcAlpha, PLbcRed, PLbcGreen, PLbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Player Location Control
		GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue = 0.3, 0.3, 0.3, 0.3; --Backcolor for Game time Control
		ShowMoney, ShowDestinyPoints, ShowBagInfos, ShowPlayerInfos, ShowEquipInfos, ShowDurabilityInfos, ShowPlayerLoc, ShowGameTime = false, false, true, true, true, true, true, true;
		_G.STM = false;
		_G.Clock24h = true;

		SaveSettings();
	end

	TBLocale = settings.Language;
	--write(tostring(AppLocaleD..TBLocale));
	import (AppLocaleD..TBLocale);

	if settings.BackColor == nil then settings.BackColor = {}; end
	if settings.BackColor.A == nil then settings.BackColor.A = string.format("%.3f", 0.3); end
	if settings.BackColor.R == nil then settings.BackColor.R = string.format("%.3f", 0.3); end
	if settings.BackColor.G == nil then settings.BackColor.G = string.format("%.3f", 0.3); end
	if settings.BackColor.B == nil then settings.BackColor.B = string.format("%.3f", 0.3); end
	bcAlpha = tonumber(settings.BackColor.A);
	bcRed = tonumber(settings.BackColor.R);
	bcGreen = tonumber(settings.BackColor.G);
	bcBlue = tonumber(settings.BackColor.B);

	if settings.Show == nil then settings.Show = {}; end

	if settings.Show.Money == nil then settings.Show.Money = {}; end
	if settings.Show.Money.V == nil then settings.Show.Money.V = false; end
	if settings.Show.Money.A == nil then settings.Show.Money.A = string.format("%.3f", 0.3); end
	if settings.Show.Money.R == nil then settings.Show.Money.R = string.format("%.3f", 0.3); end
	if settings.Show.Money.G == nil then settings.Show.Money.G = string.format("%.3f", 0.3); end
	if settings.Show.Money.B == nil then settings.Show.Money.B = string.format("%.3f", 0.3); end
	if settings.Show.Money.S == nil then settings.Show.Money.S = false; end --Show Total Money of all character on TitanBar Money control.
	ShowMoney = settings.Show.Money.V;
	MbcAlpha = tonumber(settings.Show.Money.A);
	MbcRed = tonumber(settings.Show.Money.R);
	MbcGreen = tonumber(settings.Show.Money.G);
	MbcBlue = tonumber(settings.Show.Money.B);
	_G.STM = settings.Show.Money.S;

	if settings.Show.DestinyPoints == nil then settings.Show.DestinyPoints = {}; end
	if settings.Show.DestinyPoints.V == nil then settings.Show.DestinyPoints.V = false; end
	if settings.Show.DestinyPoints.A == nil then settings.Show.DestinyPoints.A = string.format("%.3f", 0.3); end
	if settings.Show.DestinyPoints.R == nil then settings.Show.DestinyPoints.R = string.format("%.3f", 0.3); end
	if settings.Show.DestinyPoints.G == nil then settings.Show.DestinyPoints.G = string.format("%.3f", 0.3); end
	if settings.Show.DestinyPoints.B == nil then settings.Show.DestinyPoints.B = string.format("%.3f", 0.3);	end
	ShowDestinyPoints = settings.Show.DestinyPoints.V;
	DPbcAlpha = tonumber(settings.Show.DestinyPoints.A);
	DPbcRed = tonumber(settings.Show.DestinyPoints.R);
	DPbcGreen = tonumber(settings.Show.DestinyPoints.G);
	DPbcBlue = tonumber(settings.Show.DestinyPoints.B);

	if settings.Show.BagInfos == nil then settings.Show.BagInfos = {}; end
	if settings.Show.BagInfos.V == nil then settings.Show.BagInfos.V = true; end
	if settings.Show.BagInfos.A == nil then settings.Show.BagInfos.A = string.format("%.3f", 0.3); end
	if settings.Show.BagInfos.R == nil then settings.Show.BagInfos.R = string.format("%.3f", 0.3); end
	if settings.Show.BagInfos.G == nil then settings.Show.BagInfos.G = string.format("%.3f", 0.3); end
	if settings.Show.BagInfos.B == nil then settings.Show.BagInfos.B = string.format("%.3f", 0.3); end
	ShowBagInfos = settings.Show.BagInfos.V;
	BbcAlpha = tonumber(settings.Show.BagInfos.A);
	BbcRed = tonumber(settings.Show.BagInfos.R);
	BbcGreen = tonumber(settings.Show.BagInfos.G);
	BbcBlue = tonumber(settings.Show.BagInfos.B);

	if settings.Show.PlayerInfos == nil then settings.Show.PlayerInfos = {}; end
	if settings.Show.PlayerInfos.V == nil then settings.Show.PlayerInfos.V = true; end
	if settings.Show.PlayerInfos.A == nil then settings.Show.PlayerInfos.A = string.format("%.3f", 0.3); end
	if settings.Show.PlayerInfos.R == nil then settings.Show.PlayerInfos.R = string.format("%.3f", 0.3); end
	if settings.Show.PlayerInfos.G == nil then settings.Show.PlayerInfos.G = string.format("%.3f", 0.3); end
	if settings.Show.PlayerInfos.B == nil then settings.Show.PlayerInfos.B = string.format("%.3f", 0.3); end
	ShowPlayerInfos = settings.Show.PlayerInfos.V;
	PIbcAlpha = tonumber(settings.Show.PlayerInfos.A);
	PIbcRed = tonumber(settings.Show.PlayerInfos.R);
	PIbcGreen = tonumber(settings.Show.PlayerInfos.G);
	PIbcBlue = tonumber(settings.Show.PlayerInfos.B);

	if settings.Show.EquipInfos == nil then	settings.Show.EquipInfos = {}; end
	if settings.Show.EquipInfos.V == nil then	settings.Show.EquipInfos.V = true; end
	if settings.Show.EquipInfos.A == nil then	settings.Show.EquipInfos.A = string.format("%.3f", 0.3); end
	if settings.Show.EquipInfos.R == nil then	settings.Show.EquipInfos.R = string.format("%.3f", 0.3); end
	if settings.Show.EquipInfos.G == nil then	settings.Show.EquipInfos.G = string.format("%.3f", 0.3); end
	if settings.Show.EquipInfos.B == nil then	settings.Show.EquipInfos.B = string.format("%.3f", 0.3); end
	ShowEquipInfos = settings.Show.EquipInfos.V;
	EIbcAlpha = tonumber(settings.Show.EquipInfos.A);
	EIbcRed = tonumber(settings.Show.EquipInfos.R);
	EIbcGreen = tonumber(settings.Show.EquipInfos.G);
	EIbcBlue = tonumber(settings.Show.EquipInfos.B);

	if settings.Show.DurabilityInfos == nil then settings.Show.DurabilityInfos = {}; end
	if settings.Show.DurabilityInfos.V == nil then settings.Show.DurabilityInfos.V = true; end
	if settings.Show.DurabilityInfos.A == nil then settings.Show.DurabilityInfos.A = string.format("%.3f", 0.3); end
	if settings.Show.DurabilityInfos.R == nil then settings.Show.DurabilityInfos.R = string.format("%.3f", 0.3); end
	if settings.Show.DurabilityInfos.G == nil then settings.Show.DurabilityInfos.G = string.format("%.3f", 0.3); end
	if settings.Show.DurabilityInfos.B == nil then settings.Show.DurabilityInfos.B = string.format("%.3f", 0.3); end
	ShowDurabilityInfos = settings.Show.DurabilityInfos.V;
	DIbcAlpha = tonumber(settings.Show.DurabilityInfos.A);
	DIbcRed = tonumber(settings.Show.DurabilityInfos.R);
	DIbcGreen = tonumber(settings.Show.DurabilityInfos.G);
	DIbcBlue = tonumber(settings.Show.DurabilityInfos.B);

	if settings.Show.PlayerLoc == nil then settings.Show.PlayerLoc = {}; end
	if settings.Show.PlayerLoc.V == nil then settings.Show.PlayerLoc.V = true; end
	if settings.Show.PlayerLoc.A == nil then settings.Show.PlayerLoc.A = string.format("%.3f", 0.3); end
	if settings.Show.PlayerLoc.R == nil then settings.Show.PlayerLoc.R = string.format("%.3f", 0.3); end
	if settings.Show.PlayerLoc.G == nil then settings.Show.PlayerLoc.G = string.format("%.3f", 0.3); end
	if settings.Show.PlayerLoc.B == nil then settings.Show.PlayerLoc.B = string.format("%.3f", 0.3); end
	ShowPlayerLoc = settings.Show.PlayerLoc.V;
	PLbcAlpha = tonumber(settings.Show.PlayerLoc.A);
	PLbcRed = tonumber(settings.Show.PlayerLoc.R);
	PLbcGreen = tonumber(settings.Show.PlayerLoc.G);
	PLbcBlue = tonumber(settings.Show.PlayerLoc.B);

	if settings.Show.GameTime == nil then settings.Show.GameTime = {}; end
	if settings.Show.GameTime.V == nil then settings.Show.GameTime.V = true; end
	if settings.Show.GameTime.A == nil then settings.Show.GameTime.A = string.format("%.3f", 0.3); end
	if settings.Show.GameTime.R == nil then settings.Show.GameTime.R = string.format("%.3f", 0.3); end
	if settings.Show.GameTime.G == nil then settings.Show.GameTime.G = string.format("%.3f", 0.3); end
	if settings.Show.GameTime.B == nil then settings.Show.GameTime.B = string.format("%.3f", 0.3); end
	if settings.Show.GameTime.H == nil then settings.Show.GameTime.H = true; end -- True = Show clock in 24h format
	ShowGameTime = settings.Show.GameTime.V;
	GTbcAlpha = tonumber(settings.Show.GameTime.A);
	GTbcRed = tonumber(settings.Show.GameTime.R);
	GTbcGreen = tonumber(settings.Show.GameTime.G);
	GTbcBlue = tonumber(settings.Show.GameTime.B);
	_G.Clock24h = settings.Show.GameTime.H;

	if GLocale == "de" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsDE", settings ); end
	if GLocale == "en" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsEN", settings ); end
	if GLocale == "fr" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsFR", settings ); end
end
-- **^

-- **v Save settings v**
function SaveSettings()
	settings = {};
	settings.Version = Version;
	settings.Language = TBLocale;

	settings.BackColor = {};
	settings.BackColor.A = string.format("%.3f", bcAlpha);
	settings.BackColor.R = string.format("%.3f", bcRed);
	settings.BackColor.G = string.format("%.3f", bcGreen);
	settings.BackColor.B = string.format("%.3f", bcBlue);
	
	settings.Show = {};
	settings.Show.Money = {};
	settings.Show.Money.V = ShowMoney;
	settings.Show.Money.A = string.format("%.3f", MbcAlpha);
	settings.Show.Money.R = string.format("%.3f", MbcRed);
	settings.Show.Money.G = string.format("%.3f", MbcGreen);
	settings.Show.Money.B = string.format("%.3f", MbcBlue);
	settings.Show.Money.S = _G.STM; --Show Total Money of all character on TitanBar Money control.

	settings.Show.DestinyPoints = {};
	settings.Show.DestinyPoints.V = ShowDestinyPoints;
	settings.Show.DestinyPoints.A = string.format("%.3f", DPbcAlpha);
	settings.Show.DestinyPoints.R = string.format("%.3f", DPbcRed);
	settings.Show.DestinyPoints.G = string.format("%.3f", DPbcGreen);
	settings.Show.DestinyPoints.B = string.format("%.3f", DPbcBlue);

	settings.Show.BagInfos = {};
	settings.Show.BagInfos.V = ShowBagInfos;
	settings.Show.BagInfos.A = string.format("%.3f", BbcAlpha);
	settings.Show.BagInfos.R = string.format("%.3f", BbcRed);
	settings.Show.BagInfos.G = string.format("%.3f", BbcGreen);
	settings.Show.BagInfos.B = string.format("%.3f", BbcBlue);

	settings.Show.PlayerInfos = {};
	settings.Show.PlayerInfos.V = ShowPlayerInfos;
	settings.Show.PlayerInfos.A = string.format("%.3f", PIbcAlpha);
	settings.Show.PlayerInfos.R = string.format("%.3f", PIbcRed);
	settings.Show.PlayerInfos.G = string.format("%.3f", PIbcGreen);
	settings.Show.PlayerInfos.B = string.format("%.3f", PIbcBlue);

	settings.Show.EquipInfos = {};
	settings.Show.EquipInfos.V = ShowEquipInfos;
	settings.Show.EquipInfos.A = string.format("%.3f", EIbcAlpha);
	settings.Show.EquipInfos.R = string.format("%.3f", EIbcRed);
	settings.Show.EquipInfos.G = string.format("%.3f", EIbcGreen);
	settings.Show.EquipInfos.B = string.format("%.3f", EIbcBlue);

	settings.Show.DurabilityInfos = {};
	settings.Show.DurabilityInfos.V = ShowDurabilityInfos;
	settings.Show.DurabilityInfos.A = string.format("%.3f", DIbcAlpha);
	settings.Show.DurabilityInfos.R = string.format("%.3f", DIbcRed);
	settings.Show.DurabilityInfos.G = string.format("%.3f", DIbcGreen);
	settings.Show.DurabilityInfos.B = string.format("%.3f", DIbcBlue);

	settings.Show.PlayerLoc = {};
	settings.Show.PlayerLoc.V = ShowPlayerLoc;
	settings.Show.PlayerLoc.A = string.format("%.3f", PLbcAlpha);
	settings.Show.PlayerLoc.R = string.format("%.3f", PLbcRed);
	settings.Show.PlayerLoc.G = string.format("%.3f", PLbcGreen);
	settings.Show.PlayerLoc.B = string.format("%.3f", PLbcBlue);

	settings.Show.GameTime = {};
	settings.Show.GameTime.V = ShowGameTime;
	settings.Show.GameTime.A = string.format("%.3f", GTbcAlpha);
	settings.Show.GameTime.R = string.format("%.3f", GTbcRed);
	settings.Show.GameTime.G = string.format("%.3f", GTbcGreen);
	settings.Show.GameTime.B = string.format("%.3f", GTbcBlue);
	settings.Show.GameTime.H = _G.Clock24h; -- True = Show clock in 24h format

	if GLocale == "de" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsDE", settings ); end
	if GLocale == "en" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsEN", settings ); end
	if GLocale == "fr" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsFR", settings ); end
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	write( L["TBR"] );
	TBLocale = "en";
	ShowMoney, ShowDestinyPoints, ShowBagInfos, ShowPlayerInfos, ShowEquipInfos, ShowDurabilityInfos, ShowPlayerLoc, ShowGameTime  = false, false, true, true, true, true, true, true;
	_G.STM = false;

	if GLocale == "en" then tA, tR, tG, tB = 0.3, 0.3, 0.3, 0.3;
	else tA, tR, tG, tB = "0,3", "0,3", "0,3", "0,3"; end

	bcAlpha, bcRed, bcGreen, bcBlue = tA, tR, tG, tB; --Backcolor for TitanBar
	MbcAlpha, MbcRed, MbcGreen, MbcBlue = tA, tR, tG, tB; --Backcolor for Money Control
	DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue = tA, tR, tG, tB; --Backcolor for Destiny points Control
	BbcAlpha, BbcRed, BbcGreen, BbcBlue = tA, tR, tG, tB; --Backcolor for bag Control
	PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue = tA, tR, tG, tB; --Backcolor for Player infos Control
	EIbcAlpha, EIbcRed, EIbcGreen, EIbcBlue = tA, tR, tG, tB; --Backcolor for Equipment infos Control
	DIbcAlpha, DIbcRed, DIbcGreen, DIbcBlue = tA, tR, tG, tB; --Backcolor for Durability infos Control

	PLbcAlpha, PLbcRed, PLbcGreen, PLbcBlue = tA, tR, tG, tB; --Backcolor for Player Location Control
	GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue = tA, tR, tG, tB; --Backcolor for Game time Control
	_G.Clock24h = true;

	SaveSettings();
	ReloadTitanBar();
end
-- **^

function LoadCharacterWallet()
	wallet = Turbine.PluginData.Load( Turbine.DataScope.Server, "TitanBarWallet" );
	if wallet == nil then wallet = {}; end
end

-- **v Save character wallet infos v**
function SaveCharacterWallet()
	local PN = Player:GetName();

	local G = string.format("%.0f", MI["GLbl"]:GetText());
	local S = string.format("%.0f", MI["SLbl"]:GetText());
	local C = string.format("%.0f", MI["CLbl"]:GetText());
	local strData = G .. "/" .. S .. "/" .. C;

	wallet[PN] = strData;

	--table.sort( wallet );

	vWallet, i  = {}, 1;
	GoldTot, SilverTot, CopperTot = 0, 0, 0;

	for k,v in pairs(wallet) do
		if k ~= "Total" then
			vWallet[i] = {};
			vWallet[i].Name = k;

			-- Find and extract amount
			local pos1 = string.find(v, "/", 0);
			local pos2 = string.find(v, "/", pos1 + 1);
			
			local Gold = string.sub(v, 1, pos1 - 1);
			GoldTot = GoldTot + Gold;
			vWallet[i].G = Gold;

			local Silver = string.sub(v, pos1 + 1, pos2 - 1);
			SilverTot = SilverTot + Silver;
			vWallet[i].S = Silver;

			local Copper = string.sub(v, pos2 + 1, string.len(v));
			CopperTot = CopperTot + Copper;
			vWallet[i].C = Copper;

			i = i + 1;
		end
	end
	--************************************************************************
	if (string.len(CopperTot)==3) then
		local CopperTotX = CopperTot;
		SilverTot = SilverTot + string.sub(CopperTotX,1,-3);
		CopperTot = string.sub(CopperTot,2,-1);
	end
		
	if (string.len(SilverTot)==4) then
		local SilverTotX = SilverTot;
		GoldTot = GoldTot + string.sub(SilverTotX,1,-4);
		SilverTot = string.sub(SilverTot,2,-1);
	end
	--************************************************************************
	wallet["Total"] = GoldTot .. "/" .. SilverTot .. "/" .. CopperTot;

	Turbine.PluginData.Save( Turbine.DataScope.Server, "TitanBarWallet", wallet );
end
-- **^